<template>
  <svg :style="position(connection)">
    <path fill="none" stroke="white" :d="line(connection)" :style="{'--d': 'path(\''+line(connection)+'\')'}" stroke-width="1"/>
  </svg>
</template>

<script>
const roundness = 25;
const smoothConnection = true;

function $(selector) {
  if (typeof document !== "undefined")
    return document.querySelector(selector);
}

export const updateEventName = 'vlow-canvas-update';

export default {
  name: "Connection",
  props: {
    connection: {
      src: String,
      tgt: String
    }
  },
  methods: {
    position: function (foreign_key) {
      const src = $(foreign_key.src)
          , tgt = $(foreign_key.tgt);

      if (src && tgt && this.$el) {
        const src_o = src.getBoundingClientRect()
            , tgt_o = tgt.getBoundingClientRect()
        ;

        const l = Math.min(src_o.right, tgt_o.left - roundness);
        const r = Math.max(src_o.right + roundness, tgt_o.left);
        const t = Math.min(tgt_o.top + tgt_o.height / 2, src_o.top + src_o.height / 2);


        const w = Math.abs(r - l);
        const h = (Math.abs(tgt_o.top - src_o.top) + 2);

        const m = this.$el.parentElement.getBoundingClientRect();

        return {
          left: Math.floor(l - m.left) + "px",
          top: Math.floor(t - m.top) + "px",
          width: Math.floor(w) + "px",
          height: Math.floor(h) + "px"
        }
      } else return {}
    },
    line: function (foreign_key) {
      const src = $(foreign_key.src)
          , tgt = $(foreign_key.tgt);

      if (src && tgt) {
        const src_o = src.getBoundingClientRect()
            , tgt_o = tgt.getBoundingClientRect()
        ;

        const l = Math.min(src_o.right, tgt_o.left - roundness);
        const r = Math.max(src_o.right + roundness, tgt_o.left);

        const w = Math.floor(r - l);
        let h = Math.floor(tgt_o.top - src_o.top);


        let P1, P2, P3, P4;

        if (src_o.right + roundness <= tgt_o.left) {
          if (h > 0) {
            h++;
            P1 = '1,1'
            P2 = roundness + ',1'
            P3 = (w - roundness) + ',' + h
            P4 = w + ',' + h;
          } else {
            h *= -1;
            h++;
            P1 = '1,' + h
            P2 = roundness + ',' + h
            P3 = (w - roundness) + ',1'
            P4 = w + ',1'
          }
        } else {
          if (h > 0) {
            h++;
            P1 = (w - roundness) + ',0'
            P2 = w + ',0'
            P3 = '0,' + h
            P4 = roundness + ',' + h
          } else {
            h *= -1;
            h++;
            P1 = (w - roundness) + ',' + h
            P2 = w + ',' + h
            P3 = '0,0'
            P4 = roundness + ',0';
          }
        }

        if (smoothConnection) {
          return "M" + P1 + " C" + P2 + "  " + P3 + "  " + P4;
        } else {
          return "M" + P1 + " L" + P2 + " L" + P3 + " L" + P4;
        }
      } else return ''
    },
  },
  mounted() {
    if (window) {
      this.__update = () => this.$forceUpdate();
      window.addEventListener(updateEventName, this.__update)
    }
  },
  beforeDestroy() {
    if (window) {
      window.removeEventListener(updateEventName, this.__update)
    }
  }
}
</script>

<style>
svg.vlow-connection path[d=""] {
  d: var(--d);
}
</style>
